; Diretivas.s
; Desenvolvido para a placa EK-TM4C1294XL
; Exemplo de algumas Diretivas do Keil ...
; Prof. Guilherme de S. Peron	- 12/03/2018
; Prof. Marcos E. P. Monteiro	- 12/03/2018
; Prof. DaLuz           		- 22/11/2024

;################################################################################
; Declaraes EQU
;<NOME>	EQU	<VALOR>
;################################################################################
        AREA    |.text|, CODE, READONLY, ALIGN=2
        THUMB
		; Se alguma funo do arquivo for chamada em outro arquivo	
        EXPORT Start                ; Permite chamar a funo Start a partir de 
			                        ; outro arquivo. No caso startup.s
		; Se chamar alguma funo externa	
        ;IMPORT <func>              ; Permite chamar dentro deste arquivo uma 
									; funo <func>
;Endereos bases da RAM:
RAM 		EQU 	0x20000400		;Endereo do vetor
									
;################################################################################
BOLA 		EQU 	10							;Diretiva EQUATE define uma constante <=> #define
JOGADOR 	EQU 	20							;Diretiva EQUATE define uma constante <=> #define
MESA 		EQU 	0x30						;Diretiva EQUATE define uma constante <=> #define

Start
	MOV		R0, #BOLA							;R0=10
	MOV		R1, #JOGADOR						;R1=20
	MOV32	R5, STR_1							;(Diretiva) Carrega o endereo do VETOR_2 em R5 (MOV + MOVT)
percorrer_str1
	LDRB 	R6, [R5], #1						;Carrega da ROM STR_1[R5] e R5++
	CMP 	R6, #0								;Compara o valor carregado com Zero
	BNE 	percorrer_str1						;R6=0? fim do vetor; No: salta para percorrer_str1
	MOV32	R5, VETOR_1							;(Diretiva) Carrega o endereo do VETOR_1 em R5 (MOV + MOVT)
percorrer_vetor1
	LDRB 	R6, [R5], #1						;Carrega da VETOR_1[R5] e R5++
	CMP 	R6, #0								;Compara o valor carregado com Zero
	BNE 	percorrer_vetor1					;R6=0? fim do vetor; No: salta para percorrer_vetor1

Carga_RAM										;Mtodo de carga do vetor alternativo estilo C:
	MOV32	R0, Vetor_Rom1						;(Diretiva) Carrega o endereo do Vetor_Rom1 em R0 (MOV + MOVT)
	LDR		R1, =RAM							;(Diretiva) Carrega o endereo da RAM em R1 (1 x Instruo ... verificar no modo Debug)
load_vetor_ram1									;Label para controle da cpia do VRom -> VRam
	LDRB	R2,[R0],#1							;Carrega do Vrom para R2 e R2++
	STRB	R2,[R1],#1							;Carrega de R2 para Vram e R1++
	CMP		R2, #0								;R2=0?
	BNE		load_vetor_ram1						;Enquanto R2(Vrom0)!=0 salta para load_vetor_ram1

	NOP											;No Operation - consome 1 ciclo de mquina

STR_1 		DCB "UTFPR", 0							;Define Constante Byte na Rom <=> Vetor (u. char)(8 bits)
VETOR_1 	DCB 0xFF, 0xAA, 0x12, 0x14, 0			;Define Constante Byte na Rom <=> Vetor Hex (u. char)(8 bits)
VETOR_2 	DCB 123, 34, 45, 50, 0					;Define Constante Byte na Rom <=> Vetor Dec (u. char)(8 bits)
CONST_1 	DCW 0x2345, 0x1122, 0x5577, 0xFF23, 0	;Define Constante Word na Rom <=> Vetor Hex (u. s. int)(16 bits)
CONST_2 	DCD 0x11223344, 0xFF564321, 0			;Define Constante Double Word na Rom <=> Vetor Hex (u. int)(32 bits)
Vetor_Rom1	DCB 193,63,176,127,43,19,211,3,203,5,21,127,206,245,157,237,241,105,252,19,0	;Define Constante Byte na Rom <=> Vetor (u. char)(8 bits)

    ALIGN                           			; garante que o fim da seo est alinhada 
    END                             			; fim do arquivo